// programme de Frederic LETELLIER-COHEN

#include "threadtpg300.h"

#include "tpg300.h"

void RenderThread::run()
{
  etat = 0;

  // on lance une boucle infinie
  while(1)
  {

    if(etat == 0)
    {

/*
      Sleep(100); // 100 ms d'attente
      // Mauvaise solution pour Linux

      QTest::qWait( 100 ); // 100 ms d'attente
      // Marche pas

      QTest::qSleep(100); // 100 ms d'attente
      // Marche pas

      QThread::msleep(100); // 100 ms d'attente
      Fonctionne

      QEventLoop evtLoop;
      QTimer::singleShot(100, &evtLoop, SLOT(quit()));
      evtLoop.exec();
*/
      QEventLoop evtLoop;
      QTimer::singleShot(100, &evtLoop, SLOT(quit())); // 100 ms d'attente
      evtLoop.exec();
    }


    else if(etat == 1)
    {
      QEventLoop evtLoop;
      QTimer::singleShot(1000*pt->fenetre_parametres.communique_delai(), &evtLoop, SLOT(quit())); // 60*1000 ms d'attente
      evtLoop.exec();

      if(etat == 1) // verification supplementaire pour verifier un non changement d etat
      {
         etat = 0; // on va attendre que l'etat revienne a 1 pour recommencer un nouveau cycle
        event1 = new QEvent((QEvent::Type)(1)); // Faire la mesure
        QCoreApplication::postEvent(this,event1);      
      }

    }

    else if(etat == 2)
    {
      QEventLoop evtLoop;
      QTimer::singleShot(100, &evtLoop, SLOT(quit())); // 100 ms d'attente
      evtLoop.exec();
    }


  } // fin du while(1)

}


///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool RenderThread::event(QEvent *evenement)
{
  if( evenement->type() == (QEvent::Type)(1))
    pt->mesure(); // Lance la mesure

  return TRUE;
}
